## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.9

Main Page | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members | Related Pages

# XPathEnvSupportDefault Class Reference

Dummy class in order to make the XPath object happy for diagnostic purposes. More...

Inheritance diagram for XPathEnvSupportDefault:

[legend]
Collaboration diagram for XPathEnvSupportDefault:

[legend]
List of all members.

## Public Types

- typedef XalanMap< XalanDOMString,
  XalanDocument * > SourceDocsTableType
- typedef FunctionTableTypeDefinition FunctionTableType
- typedef XalanMap< XalanDOMString,
  FunctionTableType > NamespaceFunctionTablesType

## Public Member Functions

- XPathEnvSupportDefault (MemoryManagerType &theManager XALAN_DEFAULT_MEMMGR)
- virtual ~XPathEnvSupportDefault ()
- MemoryManagerType & getMemoryManager ()
- virtual void installExternalFunctionLocal (const XalanDOMString &theNamespace, const XalanDOMString &functionName, const Function &function)
    Install an external function in the local space.
- virtual void uninstallExternalFunctionLocal (const XalanDOMString &theNamespace, const XalanDOMString &functionName)
    Uninstall an external function from the local space.
- virtual XalanDocument * parseXML (MemoryManagerType &theManager, const XalanDOMString &urlString, const XalanDOMString &base)
    Provides support for XML parsing service.
- virtual XalanDocument * getSourceDocument (const XalanDOMString &theURI) const
    Get the source document for the given URI.
- virtual void setSourceDocument (const XalanDOMString &theURI, XalanDocument *theDocument)
    Associate a document with a given URI.
- virtual const XalanDOMString & findURIFromDoc (const XalanDocument *owner) const
    Given a DOM Document, tell what URI was used to parse it.
- virtual bool elementAvailable (const XalanDOMString &theNamespace, const XalanDOMString &elementName) const
    Determine if an external element is available.
- virtual bool functionAvailable (const XalanDOMString &theNamespace, const XalanDOMString &functionName) const
    Determine if a function is available.
- virtual XObjectPtr extFunction (XPathExecutionContext &executionContext, const XalanDOMString &theNamespace, const XalanDOMString &functionName, XalanNode *context, const XObjectArgVectorType &argVec, const LocatorType *locator) const
    Handle an extension function.
- virtual bool problem (eSource where, eClassification classification, const PrefixResolver *resolver, const XalanNode *sourceNode, const XalanDOMString &msg, const XalanDOMChar *uri, int lineNo, int charOffset) const
    Function that is called when a problem event occurs.
- virtual void reset ()
    Reset the instance.

## Static Public Member Functions

- void initialize (MemoryManagerType &theManager)
    Perform initialization of statics -- must be called before any processing occurs.
- void terminate ()
    Perform termination of statics.
- void installExternalFunctionGlobal (const XalanDOMString &theNamespace, const XalanDOMString &functionName, const Function &function)
    Install an external function in the global space.
- void uninstallExternalFunctionGlobal (const XalanDOMString &theNamespace, const XalanDOMString &functionName)
    Uninstall an external function from the global space.

## Protected Member Functions

- const Function * findFunction (const XalanDOMString &theNamespace, const XalanDOMString &functionName) const
    Find an external function.

## Detailed Description

Dummy class in order to make the XPath object happy for diagnostic purposes.

Author:
  David N. Bertoni

## Member Typedef Documentation

typedef FunctionTableTypeDefinition XPathEnvSupportDefault::FunctionTableType

typedef XalanMap<XalanDOMString, FunctionTableType> XPathEnvSupportDefault::NamespaceFunctionTablesType

typedef XalanMap<XalanDOMString, XalanDocument*> XPathEnvSupportDefault::SourceDocsTableType

## Constructor & Destructor Documentation

XPathEnvSupportDefault::XPathEnvSupportDefault | ( | MemoryManagerType &theManager | XALAN_DEFAULT_MEMMGR | ) |

virtual XPathEnvSupportDefault::~XPathEnvSupportDefault | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual bool XPathEnvSupportDefault::elementAvailable | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | elementName
| ) | const`[virtual]`

Determine if an external element is available.

Parameters:

  theNamespace | namespace for the element
  elementName | name of extension element

Returns:
  whether the element is available or not

Implements XPathEnvSupport.

virtual XObjectPtr XPathEnvSupportDefault::extFunction | ( | XPathExecutionContext & | executionContext,
|  | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName,
|  | XalanNode * | context,
|  | const XObjectArgVectorType & | argVec,
|  | const LocatorType * | locator
| ) | const`[virtual]`

Handle an extension function.

Parameters:

  executionContext | current execution context
  theNamespace | namespace of function
  functionName | extension function name
  argVec | vector of arguments to function
  locator | A LocatorType instance for error reporting.

Returns:
  pointer to XObject result

Implements XPathEnvSupport.

const Function* XPathEnvSupportDefault::findFunction | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName
| ) | const`[protected]`

Find an external function.

Parameters:

  theNamespace | The namespace for the function.
  functionName | The name of the function.

Returns:
  a pointer to the function if found, or 0 if not found.

virtual const XalanDOMString& XPathEnvSupportDefault::findURIFromDoc | ( | const XalanDocument * | owner | ) | const`[virtual]`

Given a DOM Document, tell what URI was used to parse it.

Needed for relative resolution.

Parameters:

  owner | source document

Returns:
  document URI

Implements XPathEnvSupport.

virtual bool XPathEnvSupportDefault::functionAvailable | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName
| ) | const`[virtual]`

Determine if a function is available.

For standard function availability, theNamespace should be an empty string.

Parameters:

  theNamespace | namespace for the function
  functionName | name of the function

Returns:
  whether the function is available or not

Implements XPathEnvSupport.

MemoryManagerType& XPathEnvSupportDefault::getMemoryManager | ( |  | ) |

virtual XalanDocument* XPathEnvSupportDefault::getSourceDocument | ( | const XalanDOMString & | theURI | ) | const`[virtual]`

Get the source document for the given URI.

Parameters:

  theURI | document URI

Returns:
  source document

Implements XPathEnvSupport.

void XPathEnvSupportDefault::initialize | ( | MemoryManagerType & | theManager | ) | `[static]`

| Perform initialization of statics -- must be called before any processing occurs. See class XPathInit.

void XPathEnvSupportDefault::installExternalFunctionGlobal | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName,
|  | const Function & | function
| ) | `[static]`

Install an external function in the global space.

Parameters:

  theNamespace | The namespace for the functionl
  functionName | The name of the function.
  function | The function to install.

virtual void XPathEnvSupportDefault::installExternalFunctionLocal | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName,
|  | const Function & | function
| ) | `[virtual]`

Install an external function in the local space.

Parameters:

  theNamespace | The namespace for the functionl
  functionName | The name of the function.
  function | The function to install.

virtual XalanDocument* XPathEnvSupportDefault::parseXML | ( | MemoryManagerType & | theManager,
|  | const XalanDOMString & | urlString,
|  | const XalanDOMString & | base
| ) | `[virtual]`

Provides support for XML parsing service.

Parameters:

  urlString | location of the XML
  base | base location for URI

Returns:
  parsed document

Implements XPathEnvSupport.

virtual bool XPathEnvSupportDefault::problem | ( | eSource | where,
|  | eClassification | classification,
|  | const PrefixResolver * | resolver,
|  | const XalanNode * | sourceNode,
|  | const XalanDOMString & | msg,
|  | const XalanDOMChar * | uri,
|  | int | lineNo,
|  | int | charOffset
| ) | const`[virtual]`

Function that is called when a problem event occurs.

Parameters:

  where | either eXMLParser, eXSLTProcessor, eXPATHParser, eXPATHProcessor, or eDataSource.
  classification | either eWarning, or eError
  resolver | resolver for namespace resolution
  sourceNode | source tree node where the problem occurred (may be 0)
  msg | string message explaining the problem.
  uri | the URI of the stylesheet, if available. May be 0;
  lineNo | line number where the problem occurred.
  charOffset | character offset where the problem.

Returns:
  true if the return is an ERROR, in which case exception will be thrown. Otherwise the processor will continue to process.

Implements XPathEnvSupport.

virtual void XPathEnvSupportDefault::reset | ( |  | ) | `[virtual]`

| Reset the instance. Implements XPathEnvSupport.

virtual void XPathEnvSupportDefault::setSourceDocument | ( | const XalanDOMString & | theURI,
|  | XalanDocument * | theDocument
| ) | `[virtual]`

Associate a document with a given URI.

Parameters:

  theURI | document URI
  theDocument | source document

Implements XPathEnvSupport.

void XPathEnvSupportDefault::terminate | ( |  | ) | `[static]`

| Perform termination of statics. See class XPathInit.

void XPathEnvSupportDefault::uninstallExternalFunctionGlobal | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName
| ) | `[static]`

Uninstall an external function from the global space.

Parameters:

  theNamespace | The namespace for the functionl
  functionName | The name of the function.

virtual void XPathEnvSupportDefault::uninstallExternalFunctionLocal | ( | const XalanDOMString & | theNamespace,
|  | const XalanDOMString & | functionName
| ) | `[virtual]`

Uninstall an external function from the local space.

Parameters:

  theNamespace | The namespace for the functionl
  functionName | The name of the function.

The documentation for this class was generated from the following file:

- XPathEnvSupportDefault.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.9 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.